package org.ow2.easywsdl.extensions.wsdl4complexwsdl.util;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.HashMap;
import java.util.Map;

import javax.xml.bind.JAXBElement;

import org.ow2.easywsdl.extensions.complexwsdl.ImportedDocuments;
import org.ow2.easywsdl.extensions.wsdl4complexwsdl.impl.ImportedDocumentsImpl;
import org.ow2.easywsdl.extensions.wsdl4complexwsdl.impl.inout.WSDL4ComplexWsdlReaderImpl;
import org.ow2.easywsdl.schema.api.absItf.AbsItfSchema;
import org.ow2.easywsdl.wsdl.api.WSDLException;
import org.ow2.easywsdl.wsdl.api.abstractItf.AbsItfDescription;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class ImportedDocumentsFilter  {



	private Map<URI, AbsItfDescription> descriptions = new HashMap<URI, AbsItfDescription>();


	private Map<URI, AbsItfSchema> schemas = new HashMap<URI, AbsItfSchema>();


	public ImportedDocumentsFilter(Document doc, WSDL4ComplexWsdlReaderImpl reader) throws WSDLException {
		NodeList elmts = doc.getDocumentElement().getElementsByTagNameNS("http://petals.ow2.org/wsdlExtensions", "importedDocuments");
		try {
			if(elmts != null && elmts.getLength() > 0) {
				Element importedDocuments = (Element) elmts.item(0);
				JAXBElement<ImportedDocuments> imptDocsElmt = reader.convertElement2ImportedDocuments(importedDocuments);
				org.ow2.easywsdl.extensions.wsdl4complexwsdl.api.ImportedDocuments imptDocs = new ImportedDocumentsImpl(imptDocsElmt.getValue(), null);
				for(org.ow2.easywsdl.extensions.wsdl4complexwsdl.api.Document imptDoc: imptDocs.getDocuments()) {
					if(imptDoc.getImportedDescription() != null) {
						descriptions.put(new URI(imptDoc.getName()), imptDoc.getImportedDescription());
					} else if(imptDoc.getImportedSchema() != null) {
						schemas.put(new URI(imptDoc.getName()), imptDoc.getImportedSchema());
					} 
				}
			}
		} catch (URISyntaxException e) {
			throw new WSDLException(e);
		}
	}


	public Map<URI, AbsItfDescription> getDescriptions() {
		return descriptions;
	}


	public Map<URI, AbsItfSchema> getSchemas() {
		return schemas;
	}





}
